#include <pthread.h>

#ifndef __DEFINES_H__
#define __DEFINES_H__
#include <pthread.h>

#define FILENAME_LENGTH 1024

#define FILE_FOUND			1
#define FILE_NOT_FOUND		2
#define FILE_HTML_UNTESTED	3

#define FILE_EXISTS			1
#define FILE_IS_DIRECTORY	2
#define FILE_DOES_NOT_EXIST	3

typedef struct{
	char *file_name;
	gint status;
	char *list[2];
} FILE_ELEMENT;

typedef struct{
	GList *file_not_found;
	GList *file_found;
	GList *file_to_test;
	GHashTable *files;
	
	char *directory_root;
	GPtrArray *html_extensions;
	GTree *myaliases;
	GPtrArray *directory_indexes;
	
	char *rc_file;
	
} SITE;

typedef struct {
	GtkWidget *label;
	GtkWidget *entry;
	GtkWidget *fm;
	GtkWidget *fs;
} GTK_FN;

typedef struct {
	SITE *site;
	pthread_t working_thread;
	
	char *pwd;
	
	GtkWidget *my_dialog;
	GtkWidget *vbox;
	GtkWidget *table;

	GTK_FN rc_file;
	GTK_FN dir_root;
	GTK_FN first_html_file;
	GTK_FN *my_fn;
	
	GtkWidget *start;
	GtkWidget *exit;
	
	GtkWidget *notebook;
	GtkWidget *nbp_files_found;
	GtkWidget *nbl_files_found;
	GtkWidget *nbw_files_found;
	GtkWidget *nbsw_files_found;
	GtkWidget *nbp_files_not_found;
	GtkWidget *nbl_files_not_found;
	GtkWidget *nbw_files_not_found;
	GtkWidget *nbsw_files_not_found;
	GtkWidget *nbp_files_to_test;
	GtkWidget *nbl_files_to_test;
	GtkWidget *nbw_files_to_test;
	GtkWidget *nbsw_files_to_test;
	
	GtkWidget *status_bar;
} GTK_UI;

#endif
