#include <stdio.h>
#include <string.h>
#include <glib.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

#include "headers.h"
#include "defines.h"


char *file_read(char *name, char* racine) {
	int fd;
	char *content;
	int len;
	
	fd = open(name, O_RDONLY);
	if(fd == -1) {
		if(errno == ENOENT) {
			printf("File not found. This is probably a bug.\n");
			content = NULL;
		} else {
			perror ("open ");
			exit(0);
		}
	} else {
		len = lseek(fd, 0, SEEK_END);
		lseek(fd, 0, SEEK_SET);
		content = (char*)malloc((len+1)*sizeof(char));
		read(fd, content, len);
		close(fd);
		content[len] = 0;
	}
	return content;
}

int file_test(FILE_ELEMENT *e, char* racine) {
/* tests if a file exists.
 * Returns : FILE_DOES_NOT_EXIST
 *           FILE_EXISTS
 *           FILE_IS_DIRECTORY
 */
	int res;
	struct stat st;
	char *s, *fn;

	
	res = FILE_DOES_NOT_EXIST;
	if(stat(e->file_name, &st)) {
		res = FILE_DOES_NOT_EXIST;
	} else {
		if(S_ISDIR(st.st_mode)) res = FILE_IS_DIRECTORY;
		else res = FILE_EXISTS;

	}
		
	return(res);
}
