#include <glib.h>
#include <gtk/gtk.h>
#include "defines.h"

/* files_to_site.c */
void site_locate_files(GTK_UI* my_ui);
					
void site_add_file_name(GTK_UI* my_ui,FILE_ELEMENT* file_element, char *scanned_fn);
							
FILE_ELEMENT *filename_path_to_absolute(SITE *site, char* new_fn, char* scanned_fn);
											
void string_to_filename_tree(	GTK_UI *my_ui,
								char *s,
								FILE_ELEMENT* scanned_file);

/* string_scan.c */
void string_scan(GTK_UI *my_ui, char* s);

/* file_utils.c */
char *file_read(char *name, char* racine);
int file_test(FILE_ELEMENT *name, char* racine);

/* main.c */
void display_usage();
int main(int argc, char **argv);

/* rc_utils.c */
void read_rc_file(SITE *site);
gint tree_strcmp(gconstpointer a, gconstpointer b);

/* site_utils.c */
SITE* site_create();
FILE_ELEMENT *site_lookup(SITE* site, char* key);
void site_add_to_file_not_found(GTK_UI* my_ui, FILE_ELEMENT *e, gchar *scanned_fn);
void site_add_to_file_found(GTK_UI* my_ui, FILE_ELEMENT *e);
void site_add_to_file_to_test(GTK_UI* my_ui, FILE_ELEMENT *e);
void site_move_to_file_found(GTK_UI* my_ui, FILE_ELEMENT *e);
void site_free_fn(gpointer d, gpointer u);
void site_free(SITE* site);
FILE_ELEMENT* site_first_untested(SITE* site);

/* ui_utils.c */
void ui_generate(SITE *site);

/* ui_callbacks.c */
gint ui_cb_start(GtkWidget *object, GTK_UI *my_ui);
gint ui_fm(GtkWidget *object, GTK_UI *my_ui, gchar *dir);
gint ui_fm_rc_file(GtkWidget *object, GTK_UI *my_ui);
gint ui_fm_dir_root(GtkWidget *object, GTK_UI *my_ui);
gint ui_fm_first_html_file(GtkWidget *object, GTK_UI *my_ui);
