#include <stdio.h>
#include <string.h>
#include <glib.h>

#include "headers.h"
#include "defines.h"


void read_rc_file(SITE *site) {
	char *content, *s1, *s2;
	char c;
	GString *alias_src, *alias_dest, *mytype, *myindex;
	
	content = file_read(site->rc_file, site->directory_root);
	s1 = content;
	
	site->myaliases = g_tree_new(&tree_strcmp);
	site->html_extensions = g_ptr_array_new();
	site->directory_indexes = g_ptr_array_new();
	g_ptr_array_add(site->html_extensions, g_string_new(".html"));

	while(s1[0]) {
		if(!g_strncasecmp(s1, "alias", 5)) {
			s1 += 6;
			while((s1[0]) && ((s1[0] == ' ' )||(s1[0] == '\t' ))) s1++;
			s2 = s1;
			while((s1[0]) && (s1[0] != ' ' ) && (s1[0] != '\t' )) s1++;
			c = s1[0];
			s1[0] = 0;
			alias_src = g_string_new(s2);
			s1[0] = c;
			while((s1[0]) && ((s1[0] == ' ' )||(s1[0] == '\t' ))) s1++;
			s2 = s1;
			while((s1[0]) && (s1[0] != '\n' ) && (s1[0] != ' ' ) && (s1[0] != '\t' )) s1++;
			c = s1[0];
			s1[0] = 0;
			alias_dest = g_string_new(s2);
			s1[0] = c;
			g_tree_insert(site->myaliases, alias_src, alias_dest);
		} else if(!g_strncasecmp(s1, "DirectoryIndex", 14)) {
			s1 += 15;
			while((s1[0]) && ((s1[0] == ' ' )||(s1[0] == '\t' ))) s1++;
			
			while((s1[0]) && (s1[0] != '\n')) {
				s2 = s1;
				while((s1[0]) && (s1[0] != '\n' ) && (s1[0] != ' ' ) && (s1[0] != '\t' )) s1++;
				c = s1[0];
				s1[0] = 0;
				g_ptr_array_add(site->directory_indexes,g_string_new(s2));
				s1[0] = c;
				while((s1[0]) && ((s1[0] == ' ' )||(s1[0] == '\t' ))) s1++;
			}
			
		} else if(!g_strncasecmp(s1, "AddType", 7)) {
			s1 += 8;
			while((s1[0]) && ((s1[0] == ' ' )||(s1[0] == '\t' ))) s1++;
			if(!g_strncasecmp(s1, "text/html", 9)) {
				s1 += 10;
				while((s1[0]) && ((s1[0] == ' ' )||(s1[0] == '\t' ))) s1++;
				s2 = s1;
				while((s1[0]) && (s1[0] != '\n' ) && (s1[0] != ' ' ) && (s1[0] != '\t' )) s1++;
				c = s1[0];
				s1[0] = 0;
				g_ptr_array_add(site->html_extensions, g_string_new(s2));
				s1[0] = c;
			}
		}
		while((s1[0]) && (s1[0] != '\n')) s1++;
		if(s1[0]) s1++;
	}
	free(content);
	
}

gint tree_strcmp(gconstpointer a, gconstpointer b) {
	return(strcmp(a,b));
}

