#include <stdio.h>
#include <string.h>
#include <glib.h>

#include "headers.h"
#include "defines.h"

void string_scan(GTK_UI *my_ui, char* s) {
	char *src, *dest;
	int in_tag;

	gtk_progress_set_percentage(GTK_PROGRESS(my_ui->status_bar),0);
	gtk_widget_draw_default(my_ui->status_bar);
/* First pass
 * ---------------> transform all separators into one space character
 */
	src = s;
	dest = s;
	while(src[0]) {
		if((src[0] == ' ') || (src[0] == 9) || (src[0] == 10) || (src[0] == 13)) {
			dest[0] = ' ';
			dest++;
			while((src[0] == ' ') || (src[0] == 9) || (src[0] == 10) || (src[0] == 13)) {
				src++;
			}
		} else {
			dest[0] = src[0];
			src++;
			dest++;
		}
	}
	dest[0] = 0;
	gtk_progress_set_percentage(GTK_PROGRESS(my_ui->status_bar),0.25);
	gtk_widget_draw_default(my_ui->status_bar);

/* Second pass
 * ---------------> Keep only <img ...>, <area ...> and <a href ...> tags.
 */	
	src = s;
	dest = s;
	while(strlen(src) > 8) {
		if(	(g_strncasecmp(src,"<a href",7) == 0) ||
			(g_strncasecmp(src,"<area ",6) == 0) ||
			(g_strncasecmp(src,"<img ",5) == 0)) {
			while((src[0]) && (src[0] != '>')) {
				dest[0] = src[0];
				src++;
				dest++;
			}
			if(src[0] == '>') {
				dest[0] = src[0];
				src++;
				dest++;
			} else src--;
		}
		src++;
	}
	dest[0] = 0;
	gtk_progress_set_percentage(GTK_PROGRESS(my_ui->status_bar),0.5);
	gtk_widget_draw_default(my_ui->status_bar);

/* Third pass
 * ---------------> Keep URLs only.
 */
	src = s;
	dest = s;
	while(strlen(src) > 8) {
		in_tag = 1;
		if(g_strncasecmp(src,"<a href",7) == 0) {
			while(src[0] != '=') src++;
			src++;
			while(src[0] == ' ') src++;
		} else if(g_strncasecmp(src,"<area ",6) == 0) {
			while(g_strncasecmp(src,"href",4)) src++;
			while(src[0] != '=') src++;
			src++;
			while(src[0] == ' ') src++;
		} else if(g_strncasecmp(src,"<img ",5) == 0) {
			while(g_strncasecmp(src," src",4)) src++;
			while(src[0] != '=') src++;
			src++;
			while(src[0] == ' ') src++;
		}
		dest[0] = '"';
		dest++;
		if(src[0] == '\'') {
			src++;
			while((src[0] != '\'') && (src[0] != '#') && (src[0] != '>')) {
				dest[0] = src[0];
				src++;
				dest++;
			}
		} else if(src[0] == '"') {
			src++;
			while((src[0] != '"') && (src[0] != '#') && (src[0] != '>')) {
				dest[0] = src[0];
				src++;
				dest++;
			}
		} else {
			while((src[0] != ' ') && (src[0] != '#') && (src[0] != '>')) {
				dest[0] = src[0];
				src++;
				dest++;
			}
		}
		while((src[0]) && (src[0] != '>')) src++;
		while((src[0]) && (src[0] != '<')) src++;
	}
	dest[0] = 0;
	gtk_progress_set_percentage(GTK_PROGRESS(my_ui->status_bar),0.75);
	gtk_widget_draw_default(my_ui->status_bar);
	
	/* Fourth pass : look for empty filenames. */
	
	src = s;
	dest = s;
	while(src[0]) {
		dest[0] = src[0];
		src++;
		if((src[0] != '"') || (dest[0] != '"')) dest++;
	}
	dest[0] = 0;

	gtk_progress_set_percentage(GTK_PROGRESS(my_ui->status_bar),1);
	gtk_widget_draw_default(my_ui->status_bar);
}
