#include <stdio.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <pthread.h>

#include "headers.h"
#include "defines.h"

gint ui_cb_start(GtkWidget *object, GTK_UI *my_ui) {
	FILE_ELEMENT *file_element;
	
	my_ui->site->rc_file = gtk_entry_get_text(GTK_ENTRY((my_ui->rc_file).entry));

	read_rc_file(my_ui->site);
	
	my_ui->site->directory_root = gtk_entry_get_text(GTK_ENTRY((my_ui->dir_root).entry));
	while(my_ui->site->directory_root[strlen(my_ui->site->directory_root)-1] == '/') my_ui->site->directory_root[strlen(my_ui->site->directory_root)-1] = 0;
	

	file_element = (FILE_ELEMENT*)malloc(sizeof(FILE_ELEMENT));
	file_element->file_name = gtk_entry_get_text(GTK_ENTRY((my_ui->first_html_file).entry));

	file_element->status = FILE_HTML_UNTESTED;
	
	site_add_file_name(my_ui, file_element, file_element->file_name);
	pthread_create(&(my_ui->working_thread), NULL,(gpointer)&site_locate_files, my_ui);
	
	return(TRUE);
}

gint file_ok_sel(GtkWidget *object, GTK_FN *my_file) {
	gchar *s;
	s = gtk_file_selection_get_filename(GTK_FILE_SELECTION(my_file->fs));
	gtk_entry_set_text(GTK_ENTRY(my_file->entry),s);
	gtk_editable_set_position(GTK_EDITABLE(my_file->entry), strlen(s));
	gtk_widget_destroy(my_file->fs);
	return(TRUE);
}

gint ui_fm(GtkWidget *object, GTK_UI *my_ui, gchar *dir) {
	gchar *label;
	gchar *s;
	GTK_FN *my_file;
	
	my_file = my_ui->my_fn;
	
	gtk_label_get(GTK_LABEL(my_file->label), &label);
	my_file->fs = gtk_file_selection_new(label);
	
	s=gtk_entry_get_text(GTK_ENTRY(my_file->entry));
	if(strlen(s)) {
		gtk_file_selection_set_filename(GTK_FILE_SELECTION(my_file->fs), s);
	} else {
		gtk_file_selection_set_filename(GTK_FILE_SELECTION(my_file->fs), dir);	
	}
	gtk_signal_connect (	GTK_OBJECT (my_file->fs), "destroy",
							(GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT(my_file->fs));
	/* Connect the ok_button to file_ok_sel function */
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (my_file->fs)->ok_button),
                               "clicked", (GtkSignalFunc) file_ok_sel, my_file );
           
	/* Connect the cancel_button to destroy the widget */
	gtk_signal_connect_object(	GTK_OBJECT (GTK_FILE_SELECTION(my_file->fs)->cancel_button),
                           		"clicked",
								(GtkSignalFunc) gtk_widget_destroy,
								GTK_OBJECT (my_file->fs));
	gtk_widget_show(my_file->fs);
	return(TRUE);
}

gint ui_fm_rc_file(GtkWidget *object, GTK_UI *my_ui) {
	gint res;
	my_ui->my_fn = &(my_ui->rc_file);
	
	res = ui_fm(object, my_ui, NULL);

	return(res);
}

gint ui_fm_dir_root(GtkWidget *object, GTK_UI *my_ui) {
	my_ui->my_fn = &(my_ui->dir_root);

	
	return(ui_fm(object, my_ui, NULL));
}

gint ui_fm_first_html_file(GtkWidget *object, GTK_UI *my_ui) {
	my_ui->my_fn = &(my_ui->first_html_file);

	return(ui_fm(object, my_ui, gtk_entry_get_text(GTK_ENTRY(my_ui->dir_root.entry))));
}
