#include <stdio.h>
#include <glib.h>
#include <gtk/gtk.h>

#include "headers.h"
#include "defines.h"

void ui_generate(SITE *site) {
/* GTK widgets */
	GTK_UI *my_ui;
	
	my_ui = (GTK_UI*)malloc(sizeof(GTK_UI));
	
	my_ui->site = site;
	
/* Generate the window */
	my_ui->my_dialog = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(my_ui->my_dialog), "link-checker");
	gtk_window_set_default_size(GTK_WINDOW(my_ui->my_dialog),500,400);
	gtk_window_set_policy(GTK_WINDOW(my_ui->my_dialog), TRUE,TRUE,TRUE);
	gtk_widget_show(my_ui->my_dialog);
	gtk_signal_connect_object(GTK_OBJECT(my_ui->my_dialog), "destroy", (GtkSignalFunc)gtk_exit, NULL);

/* Generate the first vbox */
	my_ui->vbox = gtk_vbox_new(FALSE,2);
	gtk_container_add(GTK_CONTAINER(my_ui->my_dialog), my_ui->vbox);
	gtk_widget_show(my_ui->vbox);

/* Generate the notebook */
	my_ui->notebook = gtk_notebook_new();
	gtk_notebook_set_tab_pos (GTK_NOTEBOOK(my_ui->notebook), GTK_POS_TOP);
	
	gtk_box_pack_start(GTK_BOX(my_ui->vbox), my_ui->notebook, TRUE, TRUE, 0);
	gtk_widget_show(my_ui->notebook);
	
/* Add pages to the notebook */
	my_ui->nbl_files_found = gtk_label_new("Files found");
	my_ui->nbw_files_found = gtk_clist_new(1);
	gtk_clist_column_titles_hide(GTK_CLIST(my_ui->nbw_files_found));
	my_ui->nbsw_files_found = gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(	GTK_SCROLLED_WINDOW(my_ui->nbsw_files_found),
									GTK_POLICY_ALWAYS,GTK_POLICY_ALWAYS);
	gtk_widget_show(my_ui->nbw_files_found);
	gtk_container_add(GTK_CONTAINER(my_ui->nbsw_files_found), my_ui->nbw_files_found);
	gtk_widget_show(my_ui->nbsw_files_found);
	gtk_notebook_append_page(GTK_NOTEBOOK(my_ui->notebook), my_ui->nbsw_files_found, my_ui->nbl_files_found);


	my_ui->nbl_files_to_test = gtk_label_new("Files to test");
	my_ui->nbw_files_to_test = gtk_clist_new(1);
	gtk_clist_column_titles_hide(GTK_CLIST(my_ui->nbw_files_to_test));
	my_ui->nbsw_files_to_test = gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(	GTK_SCROLLED_WINDOW(my_ui->nbsw_files_to_test),
									GTK_POLICY_ALWAYS,GTK_POLICY_ALWAYS);
	gtk_widget_show(my_ui->nbw_files_to_test);
	gtk_container_add(GTK_CONTAINER(my_ui->nbsw_files_to_test), my_ui->nbw_files_to_test);
	gtk_widget_show(my_ui->nbsw_files_to_test);
	gtk_notebook_append_page(GTK_NOTEBOOK(my_ui->notebook), my_ui->nbsw_files_to_test, my_ui->nbl_files_to_test);


	my_ui->nbl_files_not_found = gtk_label_new("Files not found");
	my_ui->nbw_files_not_found = gtk_clist_new(2);
	gtk_clist_set_column_title(GTK_CLIST(my_ui->nbw_files_not_found), 0, "In");
	gtk_clist_set_column_title(GTK_CLIST(my_ui->nbw_files_not_found), 1, "File not found");
	gtk_clist_column_titles_show(GTK_CLIST(my_ui->nbw_files_not_found));
	my_ui->nbsw_files_not_found = gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(	GTK_SCROLLED_WINDOW(my_ui->nbsw_files_not_found),
									GTK_POLICY_ALWAYS,GTK_POLICY_ALWAYS);
	gtk_widget_show(my_ui->nbw_files_not_found);
	gtk_container_add(GTK_CONTAINER(my_ui->nbsw_files_not_found), my_ui->nbw_files_not_found);
	gtk_widget_show(my_ui->nbsw_files_not_found);
	gtk_notebook_append_page(GTK_NOTEBOOK(my_ui->notebook), my_ui->nbsw_files_not_found, my_ui->nbl_files_not_found);
	
/* Add a progress bar */
	my_ui->status_bar = gtk_progress_bar_new();
	gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(my_ui->status_bar), GTK_PROGRESS_LEFT_TO_RIGHT);
	gtk_box_pack_start(GTK_BOX(my_ui->vbox), my_ui->status_bar, FALSE, FALSE, 0);
	gtk_widget_show(my_ui->status_bar);
	gtk_progress_set_percentage(GTK_PROGRESS(my_ui->status_bar),0);

/* Generate the table inside the vbox */
	my_ui->table = gtk_table_new(4,3,FALSE);
	gtk_box_pack_start(GTK_BOX(my_ui->vbox), my_ui->table, FALSE, FALSE, 0);
	gtk_widget_show(my_ui->table);

/* Generate the buttons and entries in the table */
	(my_ui->rc_file).label = gtk_label_new("Resource configuration file");
	gtk_table_attach(	GTK_TABLE(my_ui->table),
						(my_ui->rc_file).label,
						0,1,0,1,GTK_FILL, GTK_FILL,0,0);
	gtk_widget_show((my_ui->rc_file).label);

	(my_ui->dir_root).label = gtk_label_new("Root directory");
	gtk_table_attach(	GTK_TABLE(my_ui->table),
						(my_ui->dir_root).label,
						0,1,1,2,GTK_FILL, GTK_FILL,0,0);
	gtk_widget_show((my_ui->dir_root).label);

	(my_ui->first_html_file).label = gtk_label_new("First html file");
	gtk_table_attach(	GTK_TABLE(my_ui->table),
						(my_ui->first_html_file).label,
						0,1,2,3,GTK_FILL, GTK_FILL,0,0);
	gtk_widget_show((my_ui->first_html_file).label);

	(my_ui->rc_file).entry = gtk_entry_new_with_max_length(FILENAME_LENGTH);
	gtk_table_attach(	GTK_TABLE(my_ui->table),
						(my_ui->rc_file).entry,
						1,2,0,1,GTK_FILL, GTK_FILL,0,0);
	gtk_widget_show((my_ui->rc_file).entry);

	(my_ui->dir_root).entry = gtk_entry_new_with_max_length(FILENAME_LENGTH);
	gtk_table_attach(	GTK_TABLE(my_ui->table),
						(my_ui->dir_root).entry,
						1,2,1,2,GTK_FILL, GTK_FILL,0,0);
	gtk_widget_show((my_ui->dir_root).entry);

	(my_ui->first_html_file).entry = gtk_entry_new_with_max_length(FILENAME_LENGTH);
	gtk_table_attach(	GTK_TABLE(my_ui->table),
						(my_ui->first_html_file).entry,
						1,2,2,3,GTK_FILL, GTK_FILL,0,0);
	gtk_widget_show((my_ui->first_html_file).entry);

	(my_ui->rc_file).fm = gtk_button_new_with_label("->");
	gtk_table_attach(	GTK_TABLE(my_ui->table),
						(my_ui->rc_file).fm,
						2,3,0,1,GTK_FILL, GTK_FILL,0,0);
	gtk_widget_show((my_ui->rc_file).fm);
	gtk_signal_connect(GTK_OBJECT((my_ui->rc_file).fm), "clicked", (GtkSignalFunc)ui_fm_rc_file,(gpointer)my_ui);

	(my_ui->dir_root).fm = gtk_button_new_with_label("->");
	gtk_table_attach(	GTK_TABLE(my_ui->table),
						(my_ui->dir_root).fm,
						2,3,1,2,GTK_FILL, GTK_FILL,0,0);
	gtk_widget_show((my_ui->dir_root).fm);
	gtk_signal_connect(GTK_OBJECT((my_ui->dir_root).fm), "clicked", (GtkSignalFunc)ui_fm_dir_root,(gpointer)my_ui);

	(my_ui->first_html_file).fm = gtk_button_new_with_label("->");
	gtk_table_attach(	GTK_TABLE(my_ui->table),
						(my_ui->first_html_file).fm,
						2,3,2,3,GTK_FILL, GTK_FILL,0,0);
	gtk_widget_show((my_ui->first_html_file).fm);
	gtk_signal_connect(GTK_OBJECT((my_ui->first_html_file).fm), "clicked", (GtkSignalFunc)ui_fm_first_html_file,(gpointer)my_ui);

	my_ui->start = gtk_button_new_with_label("Start");
	gtk_table_attach(	GTK_TABLE(my_ui->table),
						my_ui->start,
						0,1,3,4,GTK_FILL, GTK_FILL,0,0);
	gtk_widget_show(my_ui->start);
	gtk_signal_connect(GTK_OBJECT(my_ui->start), "clicked", (GtkSignalFunc)ui_cb_start,(gpointer)my_ui);

	my_ui->exit = gtk_button_new_with_label("Exit");
	gtk_table_attach(	GTK_TABLE(my_ui->table),
						my_ui->exit,
						1,3,3,4,GTK_FILL, GTK_FILL,0,0);
	gtk_widget_show(my_ui->exit);
	gtk_signal_connect_object(GTK_OBJECT(my_ui->exit), "clicked", (GtkSignalFunc)gtk_exit, NULL);

}

